libname feb "c:\ethanol\feb05\renorm";


/* Create baseline and test fuel parameters for
   estimating fuel effects
*/

%global dataset;  /* needed to make the call symput variables global */

%macro renorm;

data base;
set &dataset
(keep=rvm t5m t9m arm olm sum oxm rvs t5s t9s ars ols sus oxs
rename=(rvm=rvpm t5m=t50m t9m=t90m arm=aromm olm=olefm sum=sulfurm oxm=oxygenm
 rvs=rvps t5s=t50s t9s=t90s ars=aroms ols=olefs sus=sulfurs oxs=oxygens)
);
if _n_  = 1;

rvpb=(6.9-rvpm)/rvps;
sulfurb=(20-sulfurm)/sulfurs;
oxygenb=(2-oxygenm)/oxygens;
t50b=(211-t50m)/t50s;
t90b=(305-t90m)/t90s;
aromb=(25-aromm)/aroms;
olefb=(6-olefm)/olefs;
oxoxb=oxygenb*oxygenb;
rvrvb=rvpb*rvpb;
rvarb=rvpb*aromb;
rvolb=rvpb*olefb;
rvt9b=rvpb*t90b;
arsub=aromb*sulfurb;
ararb=aromb*aromb;
ololb=olefb*olefb;
susub=sulfurb*sulfurb;
t9sub=t90b*sulfurb;
aroxb=aromb*oxygenb;
rvoxb=rvpb*oxygenb;
rvsub=rvpb*sulfurb;
rvt5b=rvpb*t50b;
arolb=aromb*olefb;
t5arb=t50b*aromb;
t9arb=t90b*aromb;
oloxb=olefb*oxygenb;
olt5b=olefb*t50b;
t9olb=olefb*t90b;
olsub=olefb*sulfurb;
t5oxb=t50b*oxygenb;
t5t9b=t50b*t90b;
t5sub=t50b*sulfurb;
t5t5b=t50b*t50b;
t9oxb=t90b*oxygenb;
t9t9b=t90b*t90b;
suoxb=sulfurb*oxygenb;
run;

data oxygen;
set base;

do i=0 to 70;
oxygen=i/20;

rvp1=(6.9-rvpm)/rvps;
sulfur1=(20-sulfurm)/sulfurs;
oxygen1=(oxygen-oxygenm)/oxygens;
t501=(211-t50m)/t50s;
t901=(305-t90m)/t90s;
arom1=(25-aromm)/aroms;
olef1=(6-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;

rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;



output;
end;
run;

data rvp;
set base;

do i=640 to 760;
rvp=i/100;

rvp1=(rvp-rvpm)/rvps;
sulfur1=(20-sulfurm)/sulfurs;
oxygen1=(2-oxygenm)/oxygens;
t501=(211-t50m)/t50s;
t901=(305-t90m)/t90s;
arom1=(25-aromm)/aroms;
olef1=(6-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;
rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;

output;
end;
run;

data olef;
set base;

do i=0 to 50;
olef=i/5;

rvp1=(6.9-rvpm)/rvps;
sulfur1=(20-sulfurm)/sulfurs;
oxygen1=(2-oxygenm)/oxygens;
t501=(211-t50m)/t50s;
t901=(305-t90m)/t90s;
arom1=(25-aromm)/aroms;
olef1=(olef-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;
rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;

output;
end;
run;

data sulfur;
set base;

do i=0 to 80;
sulfur=i;

rvp1=(6.9-rvpm)/rvps;
sulfur1=(sulfur-sulfurm)/sulfurs;
oxygen1=(2-oxygenm)/oxygens;
t501=(211-t50m)/t50s;
t901=(305-t90m)/t90s;
arom1=(25-aromm)/aroms;
olef1=(6-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;
rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;

output;
end;
run;

data arom;
set base;

do i=20 to 70;
arom=i/2;

rvp1=(6.9-rvpm)/rvps;
sulfur1=(20-sulfurm)/sulfurs;
oxygen1=(2-oxygenm)/oxygens;
t501=(211-t50m)/t50s;
t901=(305-t90m)/t90s;
arom1=(arom-aromm)/aroms;
olef1=(6-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;
rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;

output;
end;
run;

data t50;
set base;

do i=180 to 230;
t50=i;

rvp1=(6.9-rvpm)/rvps;
sulfur1=(20-sulfurm)/sulfurs;
oxygen1=(2-oxygenm)/oxygens;
t501=(t50-t50m)/t50s;
t901=(305-t90m)/t90s;
arom1=(25-aromm)/aroms;
olef1=(6-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;
rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;

output;
end;
run;

data t90;
set base;

do i=280 to 330;
t90=i;

rvp1=(6.9-rvpm)/rvps;
sulfur1=(20-sulfurm)/sulfurs;
oxygen1=(2-oxygenm)/oxygens;
t501=(211-t50m)/t50s;
t901=(t90-t90m)/t90s;
arom1=(25-aromm)/aroms;
olef1=(6-olefm)/olefs;
oxox1=oxygen1*oxygen1;
rvrv1=rvp1*rvp1;
rvar1=rvp1*arom1;
rvol1=rvp1*olef1;
rvt91=rvp1*t901;
arsu1=arom1*sulfur1;
arar1=arom1*arom1;
olol1=olef1*olef1;
susu1=sulfur1*sulfur1;
t9su1=t901*sulfur1;
arox1=arom1*oxygen1;
rvox1=rvp1*oxygen1;
rvsu1=rvp1*sulfur1;
rvt51=rvp1*t501;
arol1=arom1*olef1;
t5ar1=t501*arom1;
t9ar1=t901*arom1;
olox1=olef1*oxygen1;
olt51=olef1*t501;
t9ol1=olef1*t901;
olsu1=olef1*sulfur1;
t5ox1=t501*oxygen1;
t5t91=t501*t901;
t5su1=t501*sulfur1;
t5t51=t501*t501;
t9ox1=t901*oxygen1;
t9t91=t901*t901;
suox1=sulfur1*oxygen1;
rvp4=rvp1-rvpb;
sulfur4=sulfur1-sulfurb;
oxygen4=oxygen1-oxygenb;
t504=t501-t50b;
t904=t901-t90b;
arom4=arom1-aromb;
olef4=olef1-olefb;
oxox4=oxox1-oxoxb;
rvrv4=rvrv1-rvrvb;
rvar4=rvar1-rvarb;
rvol4=rvol1-rvolb;
rvt94=rvt91-rvt9b;
arsu4=arsu1-arsub;
arar4=arar1-ararb;
olol4=olol1-ololb;
susu4=susu1-susub;
t9su4=t9su1-t9sub;
arox4=arox1-aroxb;
rvox4=rvox1-rvoxb;
rvsu4=rvsu1-rvsub;
rvt54=rvt51-rvt5b;
arol4=arol1-arolb;
t5ar4=t5ar1-t5arb;
t9ar4=t9ar1-t9arb;
olox4=olox1-oloxb;
olt54=olt51-olt5b;
t9ol4=t9ol1-t9olb;
olsu4=olsu1-olsub;
t5ox4=t5ox1-t5oxb;
t5t94=t5t91-t5t9b;
t5su4=t5su1-t5sub;
t5t54=t5t51-t5t5b;
t9ox4=t9ox1-t9oxb;
t9t94=t9t91-t9t9b;
suox4=suox1-suoxb;

output;
end;
run;

/* create macro variables for estimated fuel effects */

data _null_;
set oxygen;
i=_n_-1;
call symput(  'rv1'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su1'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox1'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't51'||left(i),trim(left(put(t504,best12.))));
call symput(  't91'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar1'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol1'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox1'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv1'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar1'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol1'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt91'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu1'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar1'||left(i),trim(left(put(arar4,best12.))));
call symput('olol1'||left(i),trim(left(put(olol4,best12.))));
call symput('susu1'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su1'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu1'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt51'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol1'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar1'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar1'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox1'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox1'||left(i),trim(left(put(olox4,best12.))));
call symput('olt51'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol1'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu1'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox1'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t91'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su1'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t51'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox1'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t91'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox1'||left(i),trim(left(put(suox4,best12.))));
call symput('arox1'||left(i),trim(left(put(arox4,best12.))));

run;

data _null_;
set rvp;
i=_n_-1;
call symput(  'rv2'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su2'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox2'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't52'||left(i),trim(left(put(t504,best12.))));
call symput(  't92'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar2'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol2'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox2'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv2'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar2'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol2'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt92'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu2'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar2'||left(i),trim(left(put(arar4,best12.))));
call symput('olol2'||left(i),trim(left(put(olol4,best12.))));
call symput('susu2'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su2'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu2'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt52'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol2'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar2'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar2'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox2'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox2'||left(i),trim(left(put(olox4,best12.))));
call symput('olt52'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol2'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu2'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox2'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t92'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su2'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t52'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox2'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t92'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox2'||left(i),trim(left(put(suox4,best12.))));
call symput('arox2'||left(i),trim(left(put(arox4,best12.))));

run;

data _null_;
set olef;
i=_n_-1;
call symput(  'rv3'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su3'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox3'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't53'||left(i),trim(left(put(t504,best12.))));
call symput(  't93'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar3'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol3'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox3'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv3'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar3'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol3'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt93'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu3'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar3'||left(i),trim(left(put(arar4,best12.))));
call symput('olol3'||left(i),trim(left(put(olol4,best12.))));
call symput('susu3'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su3'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu3'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt53'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol3'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar3'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar3'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox3'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox3'||left(i),trim(left(put(olox4,best12.))));
call symput('olt53'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol3'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu3'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox3'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t93'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su3'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t53'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox3'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t93'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox3'||left(i),trim(left(put(suox4,best12.))));
call symput('arox3'||left(i),trim(left(put(arox4,best12.))));

run;

data _null_;
set sulfur;
i=_n_-1;
call symput(  'rv4'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su4'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox4'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't54'||left(i),trim(left(put(t504,best12.))));
call symput(  't94'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar4'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol4'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox4'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv4'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar4'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol4'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt94'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu4'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar4'||left(i),trim(left(put(arar4,best12.))));
call symput('olol4'||left(i),trim(left(put(olol4,best12.))));
call symput('susu4'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su4'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu4'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt54'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol4'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar4'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar4'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox4'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox4'||left(i),trim(left(put(olox4,best12.))));
call symput('olt54'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol4'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu4'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox4'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t94'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su4'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t54'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox4'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t94'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox4'||left(i),trim(left(put(suox4,best12.))));
call symput('arox4'||left(i),trim(left(put(arox4,best12.))));

run;

data _null_;
set arom;
i=_n_-1;
call symput(  'rv5'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su5'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox5'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't55'||left(i),trim(left(put(t504,best12.))));
call symput(  't95'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar5'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol5'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox5'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv5'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar5'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol5'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt95'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu5'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar5'||left(i),trim(left(put(arar4,best12.))));
call symput('olol5'||left(i),trim(left(put(olol4,best12.))));
call symput('susu5'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su5'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu5'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt55'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol5'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar5'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar5'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox5'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox5'||left(i),trim(left(put(olox4,best12.))));
call symput('olt55'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol5'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu5'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox5'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t95'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su5'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t55'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox5'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t95'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox5'||left(i),trim(left(put(suox4,best12.))));
call symput('arox5'||left(i),trim(left(put(arox4,best12.))));

run;

data _null_;
set t50;
i=_n_-1;
call symput(  'rv6'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su6'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox6'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't56'||left(i),trim(left(put(t504,best12.))));
call symput(  't96'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar6'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol6'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox6'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv6'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar6'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol6'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt96'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu6'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar6'||left(i),trim(left(put(arar4,best12.))));
call symput('olol6'||left(i),trim(left(put(olol4,best12.))));
call symput('susu6'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su6'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu6'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt56'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol6'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar6'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar6'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox6'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox6'||left(i),trim(left(put(olox4,best12.))));
call symput('olt56'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol6'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu6'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox6'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t96'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su6'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t56'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox6'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t96'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox6'||left(i),trim(left(put(suox4,best12.))));
call symput('arox6'||left(i),trim(left(put(arox4,best12.))));

run;

data _null_;
set t90;
i=_n_-1;
call symput(  'rv7'||left(i),trim(left(put(rvp4,best12.))));
call symput(  'su7'||left(i),trim(left(put(sulfur4,best12.))));
call symput(  'ox7'||left(i),trim(left(put(oxygen4,best12.))));
call symput(  't57'||left(i),trim(left(put(t504,best12.))));
call symput(  't97'||left(i),trim(left(put(t904,best12.))));
call symput(  'ar7'||left(i),trim(left(put(arom4,best12.))));
call symput(  'ol7'||left(i),trim(left(put(olef4,best12.))));
call symput('oxox7'||left(i),trim(left(put(oxox4,best12.))));
call symput('rvrv7'||left(i),trim(left(put(rvrv4,best12.))));
call symput('rvar7'||left(i),trim(left(put(rvar4,best12.))));
call symput('rvol7'||left(i),trim(left(put(rvol4,best12.))));
call symput('rvt97'||left(i),trim(left(put(rvt94,best12.))));
call symput('arsu7'||left(i),trim(left(put(arsu4,best12.))));
call symput('arar7'||left(i),trim(left(put(arar4,best12.))));
call symput('olol7'||left(i),trim(left(put(olol4,best12.))));
call symput('susu7'||left(i),trim(left(put(susu4,best12.))));
call symput('t9su7'||left(i),trim(left(put(t9su4,best12.))));
call symput('rvsu7'||left(i),trim(left(put(rvsu4,best12.))));
call symput('rvt57'||left(i),trim(left(put(rvt54,best12.))));
call symput('arol7'||left(i),trim(left(put(arol4,best12.))));
call symput('t5ar7'||left(i),trim(left(put(t5ar4,best12.))));
call symput('t9ar7'||left(i),trim(left(put(t9ar4,best12.))));
call symput('rvox7'||left(i),trim(left(put(rvox4,best12.))));
call symput('olox7'||left(i),trim(left(put(olox4,best12.))));
call symput('olt57'||left(i),trim(left(put(olt54,best12.))));
call symput('t9ol7'||left(i),trim(left(put(t9ol4,best12.))));
call symput('olsu7'||left(i),trim(left(put(olsu4,best12.))));
call symput('t5ox7'||left(i),trim(left(put(t5ox4,best12.))));
call symput('t5t97'||left(i),trim(left(put(t5t94,best12.))));
call symput('t5su7'||left(i),trim(left(put(t5su4,best12.))));
call symput('t5t57'||left(i),trim(left(put(t5t54,best12.))));
call symput('t9ox7'||left(i),trim(left(put(t9ox4,best12.))));
call symput('t9t97'||left(i),trim(left(put(t9t94,best12.))));
call symput('suox7'||left(i),trim(left(put(suox4,best12.))));
call symput('arox7'||left(i),trim(left(put(arox4,best12.))));

run;

%mend renorm;


/* MACROS for estimating fuel effects */

%macro mlall;

%do i=0 %to 70;
estimate '' rv &&rv1&i t5 &&t51&i t9 &&t91&i ar &&ar1&i ol &&ol1&i
ox &&ox1&i su &&su1&i
suox &&suox1&i t5t5 &&t5t51&i oxox &&oxox1&i t9ar &&t9ar1&i rvt9 &&rvt91&i rvol &&rvol1&i arar &&arar1&i 
arsu &&arsu1&i olol &&olol1&i rvsu &&rvsu1&i
/cl;
%end;

%do i=0 %to 120;
estimate '' rv &&rv2&i t5 &&t52&i t9 &&t92&i ar &&ar2&i ol &&ol2&i
ox &&ox2&i su &&su2&i
suox &&suox2&i t5t5 &&t5t52&i oxox &&oxox2&i t9ar &&t9ar2&i rvt9 &&rvt92&i rvol &&rvol2&i arar &&arar2&i 
arsu &&arsu2&i olol &&olol2&i rvsu &&rvsu2&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv3&i t5 &&t53&i t9 &&t93&i ar &&ar3&i ol &&ol3&i
ox &&ox3&i su &&su3&i
suox &&suox3&i t5t5 &&t5t53&i oxox &&oxox3&i t9ar &&t9ar3&i rvt9 &&rvt93&i rvol &&rvol3&i arar &&arar3&i 
arsu &&arsu3&i olol &&olol3&i rvsu &&rvsu3&i
/cl;
%end;


%do i=0 %to 80;
estimate '' rv &&rv4&i t5 &&t54&i t9 &&t94&i ar &&ar4&i ol &&ol4&i
ox &&ox4&i su &&su4&i
suox &&suox4&i t5t5 &&t5t54&i oxox &&oxox4&i t9ar &&t9ar4&i rvt9 &&rvt94&i rvol &&rvol4&i arar &&arar4&i 
arsu &&arsu4&i olol &&olol4&i rvsu &&rvsu4&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv5&i t5 &&t55&i t9 &&t95&i ar &&ar5&i ol &&ol5&i
ox &&ox5&i su &&su5&i
suox &&suox5&i t5t5 &&t5t55&i oxox &&oxox5&i t9ar &&t9ar5&i rvt9 &&rvt95&i rvol &&rvol5&i arar &&arar5&i 
arsu &&arsu5&i olol &&olol5&i rvsu &&rvsu5&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv6&i t5 &&t56&i t9 &&t96&i ar &&ar6&i ol &&ol6&i
ox &&ox6&i su &&su6&i
suox &&suox6&i t5t5 &&t5t56&i oxox &&oxox6&i t9ar &&t9ar6&i rvt9 &&rvt96&i rvol &&rvol6&i arar &&arar6&i 
arsu &&arsu6&i olol &&olol6&i rvsu &&rvsu6&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv7&i t5 &&t57&i t9 &&t97&i ar &&ar7&i ol &&ol7&i
ox &&ox7&i su &&su7&i
suox &&suox7&i t5t5 &&t5t57&i oxox &&oxox7&i t9ar &&t9ar7&i rvt9 &&rvt97&i rvol &&rvol7&i arar &&arar7&i 
arsu &&arsu7&i olol &&olol7&i rvsu &&rvsu7&i
/cl;
%end;

%mend mlall;

%macro mlnormal;

%do i=0 %to 70;
estimate '' rv &&rv1&i t5 &&t51&i t9 &&t91&i ar &&ar1&i ol &&ol1&i
ox &&ox1&i su &&su1&i
suox &&suox1&i t5t5 &&t5t51&i oxox &&oxox1&i t9ar &&t9ar1&i rvt9 &&rvt91&i rvol &&rvol1&i arar &&arar1&i 
arsu &&arsu1&i olol &&olol1&i t9ox &&t9ox1&i
/cl;
%end;

%do i=0 %to 120;
estimate '' rv &&rv2&i t5 &&t52&i t9 &&t92&i ar &&ar2&i ol &&ol2&i
ox &&ox2&i su &&su2&i
suox &&suox2&i t5t5 &&t5t52&i oxox &&oxox2&i t9ar &&t9ar2&i rvt9 &&rvt92&i rvol &&rvol2&i arar &&arar2&i 
arsu &&arsu2&i olol &&olol2&i t9ox &&t9ox2&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv3&i t5 &&t53&i t9 &&t93&i ar &&ar3&i ol &&ol3&i
ox &&ox3&i su &&su3&i
suox &&suox3&i t5t5 &&t5t53&i oxox &&oxox3&i t9ar &&t9ar3&i rvt9 &&rvt93&i rvol &&rvol3&i arar &&arar3&i 
arsu &&arsu3&i olol &&olol3&i t9ox &&t9ox3&i
/cl;
%end;


%do i=0 %to 80;
estimate '' rv &&rv4&i t5 &&t54&i t9 &&t94&i ar &&ar4&i ol &&ol4&i
ox &&ox4&i su &&su4&i
suox &&suox4&i t5t5 &&t5t54&i oxox &&oxox4&i t9ar &&t9ar4&i rvt9 &&rvt94&i rvol &&rvol4&i arar &&arar4&i 
arsu &&arsu4&i olol &&olol4&i t9ox &&t9ox4&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv5&i t5 &&t55&i t9 &&t95&i ar &&ar5&i ol &&ol5&i
ox &&ox5&i su &&su5&i
suox &&suox5&i t5t5 &&t5t55&i oxox &&oxox5&i t9ar &&t9ar5&i rvt9 &&rvt95&i rvol &&rvol5&i arar &&arar5&i 
arsu &&arsu5&i olol &&olol5&i t9ox &&t9ox5&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv6&i t5 &&t56&i t9 &&t96&i ar &&ar6&i ol &&ol6&i
ox &&ox6&i su &&su6&i
suox &&suox6&i t5t5 &&t5t56&i oxox &&oxox6&i t9ar &&t9ar6&i rvt9 &&rvt96&i rvol &&rvol6&i arar &&arar6&i 
arsu &&arsu6&i olol &&olol6&i t9ox &&t9ox6&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv7&i t5 &&t57&i t9 &&t97&i ar &&ar7&i ol &&ol7&i
ox &&ox7&i su &&su7&i
suox &&suox7&i t5t5 &&t5t57&i oxox &&oxox7&i t9ar &&t9ar7&i rvt9 &&rvt97&i rvol &&rvol7&i arar &&arar7&i 
arsu &&arsu7&i olol &&olol7&i t9ox &&t9ox7&i
/cl;
%end;

%mend mlnormal;

%macro remlnormal;

%do i=0 %to 70;
estimate '' rv &&rv1&i t5 &&t51&i t9 &&t91&i ar &&ar1&i ol &&ol1&i
ox &&ox1&i su &&su1&i
suox &&suox1&i t5t5 &&t5t51&i oxox &&oxox1&i t9ar &&t9ar1&i rvt9 &&rvt91&i rvol &&rvol1&i arar &&arar1&i 
arsu &&arsu1&i olol &&olol1&i
/cl;
%end;

%do i=0 %to 120;
estimate '' rv &&rv2&i t5 &&t52&i t9 &&t92&i ar &&ar2&i ol &&ol2&i
ox &&ox2&i su &&su2&i
suox &&suox2&i t5t5 &&t5t52&i oxox &&oxox2&i t9ar &&t9ar2&i rvt9 &&rvt92&i rvol &&rvol2&i arar &&arar2&i 
arsu &&arsu2&i olol &&olol2&i 
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv3&i t5 &&t53&i t9 &&t93&i ar &&ar3&i ol &&ol3&i
ox &&ox3&i su &&su3&i
suox &&suox3&i t5t5 &&t5t53&i oxox &&oxox3&i t9ar &&t9ar3&i rvt9 &&rvt93&i rvol &&rvol3&i arar &&arar3&i 
arsu &&arsu3&i olol &&olol3&i 
/cl;
%end;


%do i=0 %to 80;
estimate '' rv &&rv4&i t5 &&t54&i t9 &&t94&i ar &&ar4&i ol &&ol4&i
ox &&ox4&i su &&su4&i
suox &&suox4&i t5t5 &&t5t54&i oxox &&oxox4&i t9ar &&t9ar4&i rvt9 &&rvt94&i rvol &&rvol4&i arar &&arar4&i 
arsu &&arsu4&i olol &&olol4&i 
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv5&i t5 &&t55&i t9 &&t95&i ar &&ar5&i ol &&ol5&i
ox &&ox5&i su &&su5&i
suox &&suox5&i t5t5 &&t5t55&i oxox &&oxox5&i t9ar &&t9ar5&i rvt9 &&rvt95&i rvol &&rvol5&i arar &&arar5&i 
arsu &&arsu5&i olol &&olol5&i 
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv6&i t5 &&t56&i t9 &&t96&i ar &&ar6&i ol &&ol6&i
ox &&ox6&i su &&su6&i
suox &&suox6&i t5t5 &&t5t56&i oxox &&oxox6&i t9ar &&t9ar6&i rvt9 &&rvt96&i rvol &&rvol6&i arar &&arar6&i 
arsu &&arsu6&i olol &&olol6&i 
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv7&i t5 &&t57&i t9 &&t97&i ar &&ar7&i ol &&ol7&i
ox &&ox7&i su &&su7&i
suox &&suox7&i t5t5 &&t5t57&i oxox &&oxox7&i t9ar &&t9ar7&i rvt9 &&rvt97&i rvol &&rvol7&i arar &&arar7&i 
arsu &&arsu7&i olol &&olol7&i 
/cl;
%end;

%mend remlnormal;

%macro mlhigher;

%do i=0 %to 70;
estimate '' rv &&rv1&i t5 &&t51&i t9 &&t91&i ar &&ar1&i ol &&ol1&i
ox &&ox1&i su &&su1&i
olox &&olox1&i rvox &&rvox1&i susu &&susu1&i
/cl;
%end;

%do i=0 %to 120;
estimate '' rv &&rv2&i t5 &&t52&i t9 &&t92&i ar &&ar2&i ol &&ol2&i
ox &&ox2&i su &&su2&i
olox &&olox2&i rvox &&rvox2&i susu &&susu2&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv3&i t5 &&t53&i t9 &&t93&i ar &&ar3&i ol &&ol3&i
ox &&ox3&i su &&su3&i
olox &&olox3&i rvox &&rvox3&i susu &&susu3&i
/cl;
%end;


%do i=0 %to 80;
estimate '' rv &&rv4&i t5 &&t54&i t9 &&t94&i ar &&ar4&i ol &&ol4&i
ox &&ox4&i su &&su4&i
olox &&olox4&i rvox &&rvox4&i susu &&susu4&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv5&i t5 &&t55&i t9 &&t95&i ar &&ar5&i ol &&ol5&i
ox &&ox5&i su &&su5&i
olox &&olox5&i rvox &&rvox5&i susu &&susu5&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv6&i t5 &&t56&i t9 &&t96&i ar &&ar6&i ol &&ol6&i
ox &&ox6&i su &&su6&i
olox &&olox6&i rvox &&rvox6&i susu &&susu6&i
/cl;
%end;


%do i=0 %to 50;
estimate '' rv &&rv7&i t5 &&t57&i t9 &&t97&i ar &&ar7&i ol &&ol7&i
ox &&ox7&i su &&su7&i
olox &&olox7&i rvox &&rvox7&i susu &&susu7&i
/cl;
%end;

%mend mlhigher;


/* MACRO to print out estimated fuel effects to SAS listing and to an ASCII file */

%macro estprint(modnum);
data _null_;
    set tester;
    %if &modnum = 1 %then %do;
        file "c:\ethanol\feb05\renorm\nxfixed.out2.csv";
    %end;
    %else %do;
        file "c:\ethanol\feb05\renorm\nxfixed.out2.csv" mod;
    %end;
    put @1 "&modnum.,"
        @5 effect      $10. ","
       @17 estimate    best12.;
run;

data prd&modnum;
set preds;
number=_n_;
     if number <= 71  then x = (number-1)/20;
else if number <= 192 then x = (number - 72)/100 + 6.4;
else if number <= 243 then x = (number - 193)/5;
else if number <= 324 then x = (number - 244);
else if number <= 375 then x = (number - 325)/2 + 10;
else if number <= 426 then x = (number - 376) + 180;
else if number <= 477 then x = (number - 427) + 280;
per&modnum=100* ( exp(estimate)-1);
low&modnum=100* ( exp(lower)-1);
upp&modnum=100* ( exp(upper)-1);
se&modnum=100*StdErr;
     if number <= 71  then type = "OXY";
else if number <= 192 then type = "RVP";
else if number <= 243 then type = "OLE";
else if number <= 324 then type = "SUL";
else if number <= 375 then type = "ARO";
else if number <= 426 then type = "T50";
else if number <= 477 then type = "T90";
run;

proc sort data=prd&modnum;
by type x;
run;

proc print data=prd&modnum;
by type;
var x per&modnum low&modnum upp&modnum se&modnum;
title "predictions for model &modnum based on &data";
run;

%mend estprint;

%macro toascii;

data _null_;
merge prd1 prd2 prd3 prd4 prd5
      prd6;
by type x;
file 'c:\ethanol\feb05\renorm\noxmods.out2.csv' lrecl= 300;
normwt=0.2066798;
per23=per2*normwt+per3*(1-normwt);
per56=per5*normwt+per6*(1-normwt);
if _n_=1 then put
"param, x, 1, 2, 3, 4, 5, 6, 2 & 3, 5 & 6";
put
type      $3. ","
x      best8. ","
per1   best8. ","
per2   best8. ","
per3   best8. ","
per4   best8. ","
per5   best8. ","
per6   best8. ","
per23   best8. ","
per56   best8.;
run;

%mend toascii;

/* MACRO to run mixed model variants */
/* In all these cases, fixed and random interaction terms are the same (no weights)
so we don't need to have fterms and rterms in macro calls  */

%macro runmix(data, method, code, fterms, mac, number);

%let dataset = &data;

%renorm

ods output estimates=preds solutionf=tester;

PROC MIXED DATA=&data MAXITER=500 METHOD=&method NOCLPRINT ;
CLASS NEW noxcat2;
TITLE "Code &code : NOx model using &data with method &method";
title2 "and terms &fterms";

MODEL LN_NOX = RV T5 T9 AR OL OX SU 
               &fterms
               /S DDFM=RES;

RANDOM        
INT
RV T5 T9 AR OL OX SU
&fterms
/SUB=NEW;

%if &mac = mlall %then %mlall;
%if &mac = mlnormal %then %mlnormal;
%if &mac = mlhigher %then %mlhigher;
%if &mac = remlnormal %then %remlnormal;
run;

%estprint(&number);

%mend runmix;

%macro main;

    %runmix(feb.icfall, ml, arb10, suox t5t5 oxox t9ar rvt9 rvol arar arsu olol rvsu, mlall, 1);
    %runmix(feb.normal, ml, normal, oxox suox t5t5 arsu arar olol rvt9 t9ar rvol t9ox, mlnormal, 2);
    %runmix(feb.higher, ml, higher, olox susu rvox, mlhigher, 3);

    %runmix(feb.icfall, reml, arb10r, suox t5t5 oxox t9ar rvt9 rvol arar arsu olol rvsu, mlall, 4);
    %runmix(feb.normal, reml, normalr, oxox suox t5t5 arsu arar olol rvt9 t9ar rvol, remlnormal, 5);
    %runmix(feb.higher, reml, higherr, olox susu rvox, mlhigher, 6);

	%toascii;

%mend main;

%main
