libname feb "c:\ethanol\feb05\renorm";

OPTIONS LS=79 ps=59;

/* MACRO to run mixed model variants */
/* In all these cases, fixed and random interaction terms are the same (no weights)
so we don't need to have fterms and rterms in macro calls  */

%macro runmix(data, method, code, fterms);

PROC MIXED DATA=&data MAXITER=500 METHOD=&method NOCLPRINT ;
CLASS NEW noxcat2;
TITLE "Code &code : NOx model using &data with method &method";
title2 "and terms &fterms";

MODEL LN_NOX = RV T5 T9 AR OL OX SU 
               &fterms
               /S DDFM=RES;

RANDOM        
INT
RV T5 T9 AR OL OX SU
&fterms
/SUB=NEW;
run;


%mend runmix;

%macro runmix2(data, method, code, fterms);

PROC MIXED DATA=&data MAXITER=500 METHOD=&method NOCLPRINT ;
CLASS NEW noxcat2;
TITLE "Code &code : NOx model using &data with method &method";
title2 "and terms &fterms";

MODEL LN_NOX = noxcat2 RV T5 T9 AR OL OX SU 
               &fterms
               /S DDFM=RES;

RANDOM  RV T5 T9 AR OL OX SU
&fterms /SUB=NEW;
random int / group = noxcat2 sub=new;
run;


%mend runmix2;

%macro main;

/* need to use consistent normalizations for mle comparisons */

data normal higher;
set feb.icfall;
if noxcat2="Normal" then output normal;
else output higher;
run;


    %runmix(feb.icfall, ml, arb10, suox t5t5 oxox t9ar rvt9 rvol arar arsu olol rvsu);
    %runmix2(feb.icfall, ml, arb10 + veh, suox t5t5 oxox t9ar rvt9 rvol arar arsu olol rvsu);
    %runmix(feb.normal, ml, normal normed by self, oxox suox t5t5 arsu arar olol rvt9 t9ar rvol t9ox);
    %runmix(normal, ml, normal normed by icf, oxox suox t5t5 arsu arar olol rvt9 t9ar rvol t9ox);
    %runmix(normal, ml, normal + arb10 normed by icf, oxox suox t5t5 arsu arar olol rvt9 t9ar rvol t9ox rvsu);
    %runmix(feb.higher, ml, higher normed by self, olox susu rvox);
    %runmix(higher, ml, higher normed by icf, olox susu rvox);
    %runmix(higher, ml, higher + arb10 normed by icf, olox susu rvox suox t5t5 oxox t9ar rvt9 rvol arar arsu olol rvsu);  

%mend main;

%main
